﻿Imports System.IO
Imports System.Drawing
Imports System.Runtime.InteropServices

Public Class ICOFileParser

    <StructLayout(LayoutKind.Sequential)>
    Private Structure IconDirEntry
        Public Width As Byte
        Public Height As Byte
        Public ColorCount As Byte
        Public Reserved As Byte
        Public Planes As UShort
        Public BitsPerPixel As UShort
        Public ImageSize As UInteger
        Public ImageOffset As UInteger
    End Structure

    Public Function ExtractIcons(icoFilePath As String) As List(Of Icon)
        Dim icons As New List(Of Icon)()
        Dim icoBytes() As Byte = IO.File.ReadAllBytes(icoFilePath)
        Dim iconCount As Integer = icoBytes(4)
        Dim prevSize As Integer = 0
        Dim number As Integer = 0

        For i = 1 To iconCount
            Dim numArray(21) As Byte
            Dim pos1 As Integer = 0
            Dim pos2 As Integer = 0
            numArray(0) = 0
            numArray(1) = 0
            numArray(2) = 1
            numArray(3) = 0
            numArray(4) = 1
            numArray(5) = 0
            pos1 = 16 * i - 10
            For j = 1 To 16
                numArray(5 + j) = icoBytes(pos1 - 1 + j)
            Next
            ReDim Preserve numArray(22 + (numArray(18) + 256 * numArray(19) + 65536 * numArray(20) + numArray(14) + 256 * numArray(15) + 65536 * numArray(16) - 1) - (numArray(18) + 256 * numArray(19) + 65536 * numArray(20)))
            For j = numArray(18) + 256 * numArray(19) + 65536 * numArray(20) To numArray(18) + 256 * numArray(19) + +65536 * numArray(20) + numArray(14) + 256 * numArray(15) + 65536 * numArray(16) + -1
                numArray(22 + pos2) = icoBytes(pos2 + prevSize + 16 * iconCount + 6)
                pos2 = pos2 + 1
            Next
            prevSize = numArray(18) + 256 * numArray(19) + 65536 * numArray(20) + numArray(14) + 256 * numArray(15) + 65536 * numArray(16) - 1 - 16 * IconCount - 5
            numArray(18) = 22
            numArray(19) = 0
            numArray(20) = 0
            Number = Number + 1

            Try
                ' Open the ICO file and read its contents
                Using ms As MemoryStream = New MemoryStream(numArray)
                    Dim ico As New Icon(ms)
                    icons.Add(ico) ' Add the single icon to the list
                End Using
            Catch ex As Exception
                MessageBox.Show("Error adding icon: " & ex.Message)
                Form1.toolStripStatusLabel.Text = "Error adding icon."
            End Try
        Next

        Return icons
    End Function
End Class

